import java.awt.*;
import java.applet.*;
import java.awt.event.*;

public class PusleSpilTal extends Applet implements KeyListener  {

  Graphics graphics;
  TextField textField;
  static int width,height;
  static int brikWidth, brikHeight;
  static String[] tal = {"1","2","3","4","5","6","7","8","9",
                         "10","11","12","13","14","15",""};
  static final int SOEJLER  = 4;
  static final int RAEKKER = 4;

  // De fire retninger en brik kan flyttes, nummereres med uret.

  static final int NORD = 0;
  static final int SYD= 2;
  static final int OEST = 1;
  static final int VEST= 3;

  static boolean start=true, blanderBrikker;
  static int gammelRetning;

// Begyndelsesposition for det tomme felt

  int tomtX = SOEJLER-1;
  int tomtY = RAEKKER-1;

  // De to tabeller nedenfor er forskydningen p x og y i felter svarende til de 4 retninger
  // NORD, OEST, SYD, VEST

  int deltaX[] = {0,1,0,-1};
  int deltaY[] = {-1,0,1,0};

  // Aktuelle forskydning

  int dx, dy;

  //Pixelposition

  int x,y;

  int offsetY=50;

  public void init() {
    width=getBounds().width;
    height=getBounds().height;
    brikWidth= width /SOEJLER;
    brikHeight = (height-offsetY)/RAEKKER;
    textField = new TextField("Tryk Enter for at starte puslespillet");
    this.add(textField, BorderLayout.SOUTH);
    textField.addKeyListener(this);
  }

  public void paint(Graphics graphics) {
    this.graphics = graphics;
    if (start) {
      int bh=brikHeight*RAEKKER/5;
      graphics.setFont(new Font("Serif", Font.BOLD, bh));
      graphics.setColor(Color.red);
      for(int i=0; i<SOEJLER; i++)
        for (int j=0; j<RAEKKER; j++)
          if (j*RAEKKER+i+1<10)
            graphics.drawString(tal[j*RAEKKER+i],i*brikWidth+30,j*brikHeight+bh+offsetY);
          else
            graphics.drawString(tal[j*RAEKKER+i],i*brikWidth+10,j*brikHeight+bh+offsetY);
      delay(50);
      tegnBrikker();
    }
    textField.requestFocus();
  }

  private void tegnBrikker() {
    for (int raekke=0; raekke < RAEKKER; raekke++) {
      for (int soejle=0; soejle < SOEJLER; soejle++) {
        tegnBrik(raekke,soejle);
      }
    }
  }

  private int modsatRetning(int retning) {
    return (retning+2)%4;
  }

  private void udfyldTomtFelt(int naboRetning) {

    int naboX;
    int naboY;
    if(!IllegaltFelt(naboRetning)) {
      if (start) {
        gammelRetning=naboRetning;
        start=false;
        blanderBrikker=true;
      }
      else {
        if (blanderBrikker) {
          if (naboRetning==modsatRetning(gammelRetning)) return;
        }
      }
      gammelRetning=naboRetning;
      naboX = tomtX + deltaX[naboRetning];
      naboY = tomtY + deltaY[naboRetning];
      flytBrik (naboY, naboX, modsatRetning(naboRetning));
      tomtX = naboX;
      tomtY = naboY;
      delay(50);
    }
  }

  private boolean IllegaltFelt(int retning) {
    dx = deltaX[retning];
    dy = deltaY[retning];
    int legalX = tomtX + dx;
    int legalY = tomtY + dy;
    if ((legalX < 0) || (legalX >= SOEJLER))
      return true;
    else if ((legalY < 0) || (legalY >= RAEKKER))
      return true;
    else
      return false;
  }

  private void flytBrik(int raekke, int soejle, int retning) {

    graphics=this.getGraphics();

    dx = deltaX[retning];
    dy = deltaY[retning];
    x = soejle*brikWidth;
    y = raekke*brikHeight+offsetY;
    if (dx != 0) {
      for (int i=0; i < brikWidth; i++) {
        graphics.copyArea(x+(i * dx),y, brikWidth, brikHeight, dx, 0);
        delay(10);
      }
    }
    else {
      for (int i=0; i < brikHeight; i++) {
        graphics.copyArea(x,y+(i * dy), brikWidth, brikHeight, 0, dy);
        delay(10);
      }
    }
    textField.requestFocus();
  }

  private void tegnBrik(int raekke, int soejle) {

    x = soejle*brikWidth;
    y = raekke*brikHeight+offsetY;

    graphics.setColor(Color.gray);
    graphics.drawRect(x,y, brikWidth-1, brikHeight-1);
    graphics.setColor(Color.white);
    graphics.drawRect(x+1,y+1, brikWidth-3, brikHeight-3);
    graphics.setColor(Color.gray);
    graphics.drawRect(x+2,y+2, brikWidth-5, brikHeight-5);
  }

  private void delay(int ms) {
    try {
      Thread.sleep(ms);
    }
    catch (Exception ignored) {
    }
  }

  public void keyPressed(KeyEvent keyEvent){
    switch (keyEvent.getKeyCode()) {
      case KeyEvent.VK_UP: {
        System.out.println("Hit VK_UP");
        udfyldTomtFelt(SYD);
        break;
      }
      case KeyEvent.VK_LEFT: {
        System.out.println("Hit VK_LEFT");
        udfyldTomtFelt(OEST);
        break;
      }
      case KeyEvent.VK_RIGHT: {
        System.out.println("Hit VK_RIGHT");
        udfyldTomtFelt(VEST);
        break;
      }
      case KeyEvent.VK_DOWN: {
        System.out.println("Hit VK_DOWN");
        udfyldTomtFelt(NORD);
        break;
      }
      case KeyEvent.VK_ENTER: {
        if (start) {
          System.out.println("Hit VK_ENTER");
          for (int i=0;i<100;i++) {
            int retning = (int) (Math.random()*4);
            udfyldTomtFelt(retning);
          }
          blanderBrikker=false;
          textField.setText("Brug piletasterne til at flytte brikkerne");
        }
        break;
      }
    }
  }

  public void keyTyped(KeyEvent keyEvent) {
  }

  public void keyReleased(KeyEvent keyEvent){
  }
}
