import java.awt.*;
import java.applet.*;
import java.awt.event.*;

public class PusleSpilTalOffScreen extends Applet implements KeyListener  {

  Graphics imageGraphics;
  TextField textField;
  static DrawingCanvas canvas;
  static int width,height;
  static int brikWidth, brikHeight;
  static String[] tal = {"1","2","3","4","5","6","7","8","9",
                         "10","11","12","13","14","15","16"};
  static final int SOEJLER  = 4;
  static final int RAEKKER = 4;

  // De fire retninger en brik kan flyttes, nummereres med uret.

  static final int NORD = 0;
  static final int SYD= 2;
  static final int OEST = 1;
  static final int VEST= 3;

  static boolean start=true, blanderBrikker;
  static int gammelRetning;

  int tomtX = SOEJLER-1;// Begyndelsesposition for det tomme felt
  int tomtY = RAEKKER-1;

  // De to tabeller nedenfor er forskydningen p x og y i felter svarende til de 4 retninger

  int deltaX[] = {0,1,0,-1}; //X forskydning NORD, OEST, SYD, VEST
  int deltaY[] = {-1,0,1,0};

  // Aktuelle forskydning
  int dx, dy;

  //Pixelposition
  int x,y;

  int offsetY=50;

  public void init() {
    width=getBounds().width;
    height=getBounds().height;
    brikWidth= width /SOEJLER;
    brikHeight = (height-50)/RAEKKER;
    this.getComponents();
    canvas = new DrawingCanvas(width,height-offsetY);
    this.add(canvas);
    Image offScreenImage = canvas.getOffscreenImage();
    Graphics imageGraphics = offScreenImage.getGraphics();
    Graphics screen = canvas.getGraphics();

    textField = new TextField("Tryk Enter for at starte puslespillet");
    this.add(textField, BorderLayout.SOUTH);
    textField.addKeyListener(this);
    int bh=brikHeight*4/5;
    imageGraphics.setFont(new Font("Serif", Font.BOLD, bh));
    imageGraphics.setColor(Color.red);
    for(int i=0; i<SOEJLER; i++)
      for (int j=0; j<RAEKKER; j++)
        if (j*4+i+1<10)
          imageGraphics.drawString(tal[j*4+i],i*brikWidth+30,j*brikHeight+bh);
        else
          imageGraphics.drawString(tal[j*4+i],i*brikWidth+10,j*brikHeight+bh);

    imageGraphics.setColor(Color.white);
    delay(50);
    tegnBrikker(canvas);

    textField.requestFocus();
  }

  private void tegnBrikker(DrawingCanvas canvas) {
    for (int raekke=0; raekke < RAEKKER; raekke++) {
      for (int soejle=0; soejle < SOEJLER; soejle++) {
        tegnBrik(canvas, raekke,soejle);
      }
    }
  }

  private int modsatRetning(int retning) {
    return (retning+2)%4;
  }

  private void udfyldTomtFelt(DrawingCanvas canvas, int naboRetning) {

    int naboX;
    int naboY;
    if(!IllegaltFelt(naboRetning)) {
      if (start) {
        gammelRetning=naboRetning;
        start=false;
        blanderBrikker=true;
      }
      else {
        if (blanderBrikker) {
          if (naboRetning==modsatRetning(gammelRetning)) return;
        }
      }
      gammelRetning=naboRetning;
      naboX = tomtX + deltaX[naboRetning];
      naboY = tomtY + deltaY[naboRetning];
      flytBrik (canvas, naboX, naboY, modsatRetning(naboRetning));
      tomtX = naboX;
      tomtY = naboY;
      delay(50);
    }
  }

  private boolean IllegaltFelt(int retning) {
    dx = deltaX[retning];
    dy = deltaY[retning];
    int legalX = tomtX + dx;
    int legalY = tomtY + dy;
    if ((legalX < 0) || (legalX >= SOEJLER))
      return true;
    else if ((legalY < 0) || (legalY >= RAEKKER))
      return true;
    else
      return false;
  }

  private void flytBrik(DrawingCanvas canvas, int raekke, int soejle, int retning) {

    Image offScreenImage = canvas.getOffscreenImage();
    Graphics imageGraphics = offScreenImage.getGraphics();
    Graphics screen = canvas.getGraphics();

    dx = deltaX[retning];
    dy = deltaY[retning];
    x = raekke * brikWidth;
    y = soejle * brikHeight;
    if (dx != 0) {
      for (int i=0; i < brikWidth; i++) {
        imageGraphics.copyArea(x+(i * dx),y, brikWidth, brikHeight, dx, 0);
        canvas.paint(screen);
      }
    }
    else {
      for (int i=0; i < brikHeight; i++) {
        imageGraphics.copyArea(x,y+(i * dy), brikWidth, brikHeight, 0, dy);
        canvas.paint(screen);
      }
    }
    canvas.paint(screen);
    textField.requestFocus();
  }

  private void tegnBrik(DrawingCanvas canvas, int raekke, int soejle) {

    Image offScreenImage = canvas.getOffscreenImage();
    Graphics imageGraphics = offScreenImage.getGraphics();
    Graphics screen = canvas.getGraphics();

    x = raekke * brikWidth;
    y = soejle * brikHeight;

    imageGraphics.setColor(Color.white);

    if ((soejle==SOEJLER-1) && (raekke==RAEKKER-1))
      imageGraphics.fillRect(x,y, brikWidth, brikHeight);

    imageGraphics.setColor(Color.gray);
    imageGraphics.drawRect(x,y, brikWidth-1, brikHeight-1);
    imageGraphics.setColor(Color.white);
    imageGraphics.drawRect(x+1,y+1, brikWidth-3, brikHeight-3);
    imageGraphics.setColor(Color.gray);
    imageGraphics.drawRect(x+2,y+2, brikWidth-5, brikHeight-5);
    imageGraphics.setColor(Color.white);

    canvas.paint(screen);
  }

  private void delay(int ms) {
    try {
      Thread.sleep(ms);
    }
    catch (Exception ignored) {
    }
  }

  public void keyPressed(KeyEvent keyEvent){
    switch (keyEvent.getKeyCode()) {
      case KeyEvent.VK_UP: {
        System.out.println("Hit VK_UP");
        udfyldTomtFelt(canvas,SYD);
        break;
      }
      case KeyEvent.VK_LEFT: {
        System.out.println("Hit VK_LEFT");
        udfyldTomtFelt(canvas,OEST);
        break;
      }
      case KeyEvent.VK_RIGHT: {
        System.out.println("Hit VK_RIGHT");
        udfyldTomtFelt(canvas,VEST);
        break;
      }
      case KeyEvent.VK_DOWN: {
        System.out.println("Hit VK_DOWN");
        udfyldTomtFelt(canvas,NORD);
        break;
      }
      case KeyEvent.VK_ENTER: {
        if (start) {
          System.out.println("Hit VK_ENTER");
          for (int i=0;i<100;i++) {
            int retning = (int) (Math.random()*4);
            udfyldTomtFelt(canvas,retning);
          }
          blanderBrikker=false;
          textField.setText("Brug piletasterne til at flytte brikkerne");
        }
        break;
      }
    }
  }
  public void keyTyped(KeyEvent keyEvent) {
  }

  public void keyReleased(KeyEvent keyEvent){
  }
}

class DrawingCanvas extends Component {
  int width,height;

  DrawingCanvas(int width, int height) {
    this.width = width;
    this.height = height;
  }

  private Image offscreenImage;

  public void paint(Graphics screen) {
    if (offscreenImage!=null) screen.drawImage(offscreenImage,0,0,width,height,null);
  }

  public Image getOffscreenImage() {
    if (offscreenImage==null) offscreenImage = createImage(width,height);
    return offscreenImage;
  }

  public Dimension getMinimumSize() {
    return new Dimension(width,height);
  }

  public Dimension getPreferredSize() {
      return new Dimension(width,height);
  }
}
