import java.awt.*;
import java.applet.*;
import java.awt.image.*;
import java.awt.event.*;

public class PusleSpilTextOffScreen extends Applet implements KeyListener  {

  Graphics imageGraphics;
  TextField textField;
  static DrawingCanvas canvas;
  static int width,height;
  static int brikWidth, brikHeight;
  static final int SOEJLER  = 5;
  static final int RAEKKER = 5;

  // De fire retninger en brik kan flyttes, nummereres med uret.

  static final int NORD = 0;
  static final int SYD= 2;
  static final int OEST = 1;
  static final int VEST= 3;

  static boolean start=true, blanderBrikker;
  static int gammelRetning;

  int tomtX = SOEJLER-1;// Begyndelsesposition for det tomme felt
  int tomtY = RAEKKER-1;

  // De to tabeller nedenfor er forskydningen p x og y i felter svarende til de 4 retninger

  int xRetninger[] = {0,1,0,-1};
  int yRetninger[] = {-1,0,1,0};
  int xRetning, yRetning; // Aktuelle forskydning
  int x,y;
  int offsetY=50;

  public void init() {
    width=getBounds().width;
    height=getBounds().height;
    brikWidth= width /SOEJLER;
    brikHeight = (height-50)/RAEKKER;
    this.getComponents();
    canvas = new DrawingCanvas(width,height-offsetY);
    this.add(canvas);
    Image offScreenImage = canvas.getOffscreenImage();
    Graphics imageGraphics = offScreenImage.getGraphics();
    Graphics screen = canvas.getGraphics();

    textField = new TextField("Tryk Enter for at starte puslespillet");
    this.add(textField, BorderLayout.SOUTH);
    textField.addKeyListener(this);

    imageGraphics.setFont(new Font("Serif", Font.BOLD, 75));
    imageGraphics.drawString("Hello Wide",10,100);
    imageGraphics.drawString("World",50,200);
    imageGraphics.drawString("Web Net",20,300);
    imageGraphics.setColor(Color.white);
    delay(50);
    tegnBrikker(canvas);

    textField.requestFocus();
  }

  private void tegnBrikker(DrawingCanvas canvas) {
    for (int raekke=0; raekke < RAEKKER; raekke++) {
      for (int soejle=0; soejle < SOEJLER; soejle++) {
        tegnBrik(canvas, raekke,soejle);
      }
    }
  }

 private int modsatRetning(int retning) {
   switch(retning) {
     case NORD: return SYD;
     case SYD:  return NORD;
     case OEST: return VEST;
     case VEST: return OEST;
   }
   return NORD;
 }
 private void udfyldTomtFelt(DrawingCanvas canvas, int naboRetning) {
    int bevaegeRetning=modsatRetning(naboRetning);
    int naboX;
    int naboY;
    if(!IllegaltFelt(naboRetning)) {
      if (start) {
        gammelRetning=naboRetning;
        start=false;
        blanderBrikker=true;
      }
      else {
        if (blanderBrikker) {
          if (naboRetning==modsatRetning(gammelRetning)) return;
        }
      }
      gammelRetning=naboRetning;
      naboX = tomtX + xRetninger[naboRetning];
      naboY = tomtY + yRetninger[naboRetning];
      System.out.println("Tomt Felt: (" + tomtX + "," + tomtY+")");
      System.out.println("NaboFelt: (" + naboX + "," + naboY+")");
      flytBrik (canvas, naboX, naboY, bevaegeRetning);
      tomtX = naboX;
      tomtY = naboY;
      delay(50);
    }
  }

  private boolean IllegaltFelt(int retning) {
    xRetning = xRetninger[retning];
    yRetning = yRetninger[retning];
    int legalX = tomtX + xRetning;
    int legalY = tomtY + yRetning;
    if ((legalX < 0) || (legalX >= SOEJLER))
      return true;
    else if ((legalY < 0) || (legalY >= RAEKKER))
      return true;
    else
      return false;
  }

  private void flytBrik(DrawingCanvas canvas, int raekke, int soejle, int retning) {

    Image offScreenImage = canvas.getOffscreenImage();
    Graphics imageGraphics = offScreenImage.getGraphics();
    Graphics screen = canvas.getGraphics();

    xRetning = xRetninger[retning];
    yRetning = yRetninger[retning];
    x = raekke * brikWidth;
    y = soejle * brikHeight;
    if (xRetning != 0) {
      for (int i=0; i < brikWidth; i++) {
        imageGraphics.copyArea(x+(i * xRetning),y, brikWidth, brikHeight, xRetning, 0);
        canvas.paint(screen);
        //delay(50);
      }
    }
    else {
      for (int i=0; i < brikHeight; i++) {
        imageGraphics.copyArea(x,y+(i * yRetning), brikWidth, brikHeight, 0, yRetning);
        canvas.paint(screen);
        //delay(50);
      }
    }
    canvas.paint(screen);
    textField.requestFocus();
  }

  private void tegnBrik(DrawingCanvas canvas, int raekke, int soejle) {

    Image offScreenImage = canvas.getOffscreenImage();
    Graphics imageGraphics = offScreenImage.getGraphics();
    Graphics screen = canvas.getGraphics();

    x = raekke * brikWidth;
    y = soejle * brikHeight;

    imageGraphics.setColor(Color.white);

    if ((soejle==SOEJLER-1) && (raekke==RAEKKER-1))
      imageGraphics.fillRect(x,y, brikWidth, brikHeight);

    imageGraphics.setColor(Color.gray);
    imageGraphics.drawRect(x,y, brikWidth-1, brikHeight-1);
    imageGraphics.setColor(Color.white);
    imageGraphics.drawRect(x+1,y+1, brikWidth-3, brikHeight-3);
    imageGraphics.setColor(Color.gray);
    imageGraphics.drawRect(x+2,y+2, brikWidth-5, brikHeight-5);
    imageGraphics.setColor(Color.white);

    canvas.paint(screen);
  }

  private void delay(int ms) {
    try {
      Thread.sleep(ms);
    }
    catch (Exception ignored) {
    }
  }

  public void keyPressed(KeyEvent keyEvent){
    switch (keyEvent.getKeyCode()) {
      case KeyEvent.VK_UP: {
        System.out.println("Hit VK_UP");
        udfyldTomtFelt(canvas,SYD);
        break;
      }
      case KeyEvent.VK_LEFT: {
        System.out.println("Hit VK_LEFT");
        udfyldTomtFelt(canvas,OEST);
        break;
      }
      case KeyEvent.VK_RIGHT: {
        System.out.println("Hit VK_RIGHT");
        udfyldTomtFelt(canvas,VEST);
        break;
      }
      case KeyEvent.VK_DOWN: {
        System.out.println("Hit VK_DOWN");
        udfyldTomtFelt(canvas,NORD);
        break;
      }
      case KeyEvent.VK_ENTER: {
        if (start) {
          System.out.println("Hit VK_ENTER");
          for (int i=0;i<100;i++) {
            int retning = (int) (Math.random()*4);
            udfyldTomtFelt(canvas,retning);
          }
          blanderBrikker=false;
          textField.setText("Brug piletasterne til at flytte brikkerne");
        }
        break;
      }
    }
  }
  public void keyTyped(KeyEvent keyEvent) {
  }

  public void keyReleased(KeyEvent keyEvent){
  }
}

class DrawingCanvas extends Component {
  int width,height;

  DrawingCanvas(int width, int height) {
    this.width = width;
    this.height = height;
  }

  private Image offscreenImage;

  public void paint(Graphics screen) {
    if (offscreenImage!=null) screen.drawImage(offscreenImage,0,0,width,height,null);
  }

  public Image getOffscreenImage() {
    if (offscreenImage==null) offscreenImage = createImage(width,height);
    return offscreenImage;
  }

  public Dimension getMinimumSize() {
    return new Dimension(width,height);
  }

  public Dimension getPreferredSize() {
      return new Dimension(width,height);
  }
}
